package com.incubator.game.data.entity;

import com.incubator.game.player.Player;
import com.incubator.game.util.JDGDUtils;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 房间数据实体类
 * 作者：agui
 * 自动创建时间：2022-10-01 02:24:37
 */
public class RoomPO {
	/** 房间号 */
	public int roomId;
	/** 房间玩法类型 1:经典掼蛋 */
	public int type;
	/** 房主playerId **/
	public String ownerId = "";
	/** 玩家id集合 [key:玩家id, value:玩家对象]**/
	public Map<String, Player> playerIds = new HashMap<>();
	/** 玩家 [key:座位号， value:玩家对象] **/
	public Map<Integer, Player> playerMap = new HashMap<>();

	//**************************配置相关***************************
	/** 最大人数 **/
	public int maxNum;
	/** 最大局数 **/
	public int maxRound;

	/** 牌库 **/
	public List<Integer> cardList = new ArrayList<>();

	/** 检测标记 **/
	public boolean flag;
	/** 时间秒数 **/
	public int time;
	/** 房间状态(0等待 1开局 2进行中 3已结束) **/
	public int state;
	/** 当前局数 **/
	public int curRound;
	/** 庄家位置 **/
	public int zhuangPos;
	/** 当前级牌点数 **/
	public int curLevelPoint;
	/** 当前级牌点数下标 **/
	public int curLevelIndex;
	/** 当前操作玩家 **/
	public Player currentPlayer;
	/** 当前出牌玩家打出的牌集合 **/
	public int[] curDisCardList = new int[]{};
	/** 当前出牌玩家打出的牌型 **/
	public JDGDUtils.CardType curDisCardType;
	/** 当前出牌的玩家 **/
	public Player disCardPlayer;
	/** 点击过玩家列表 **/
	public List<String> passList = new ArrayList<>();

	/** 结算列表[key:1-4游, value:玩家] **/
	public Map<Integer, Player> result = new HashMap<>();

	public RoomPO() {}

	public void init() {
		this.roomId = 0;
		this.type = 0;
		this.ownerId = "";
		this.playerIds = new HashMap<>();
		this.playerMap = new HashMap<>();
		this.maxNum = 0;
		this.maxRound = 0;
		this.cardList = new ArrayList<>();
		this.flag = false;
		this.time = -1;
		this.state = 0;
		this.curRound = 0;
		this.zhuangPos = -1;
		this.curLevelPoint = 0;
		this.curLevelIndex = 0;
		this.currentPlayer = null;
		this.curDisCardList = new int[]{};
		this.curDisCardType = null;
		this.disCardPlayer = null;
		this.passList = new ArrayList<>();
		this.result = new HashMap<>();
	}
}
